package com.ruoyi.platform.service.impl;

import java.util.concurrent.Executors;
import java.lang.invoke.SerializedLambda;
import com.ruoyi.three.handle.OperateResult;
import com.ruoyi.three.handle.impl.DeleteTweetOperate;
import java.util.Collection;
import com.ruoyi.three.handle.Operate;
import com.ruoyi.three.handle.impl.UserTweetsOperate;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.ruoyi.three.enums.AccountEnum;
import java.util.Arrays;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Set;
import org.springframework.util.CollectionUtils;
import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.platform.domain.PlatformAccount;
import com.ruoyi.platform.repository.IPlatformAccountRepository;
import java.util.concurrent.ExecutorService;
import org.springframework.stereotype.Service;
import com.ruoyi.platform.service.IPlatformAccountService;

@Service
public class PlatformAccountServiceImpl implements IPlatformAccountService
{
    static ExecutorService executorService;
    private final IPlatformAccountRepository platformAccountRepository;
    
    public void modify(PlatformAccount platformAccount) {
        platformAccount.setUpdateTime(DateUtils.getNowDate());
        this.platformAccountRepository.updateById(platformAccount);
    }
    
    public void removeByIds(List<String> ids) {
        this.platformAccountRepository.removeByIds(ids);
    }
    
    public void removeByStatus(String status) {
        Set<String> accountIds = this.platformAccountRepository.listIdByStatus(status);
        if (CollectionUtils.isEmpty(accountIds)) {
            return;
        }
        this.platformAccountRepository.removeByIds(accountIds);
        return;
    }
    
    public List<PlatformAccount> listByGroupIds(String[] groupIds) {
        return this.platformAccountRepository.list((Wrapper)new LambdaQueryWrapper<PlatformAccount>().in((com.baomidou.mybatisplus.core.toolkit.support.SFunction<com.ruoyi.platform.domain.PlatformAccount,java.lang.String>)PlatformAccount::getGroupId, Arrays.asList(groupIds)));
    }
    
    public void statusHandle(String userId, AccountEnum accountEnum) {
        PlatformAccountServiceImpl.executorService.execute(()/*  */ -> this.platformAccountRepository.update((Wrapper)((LambdaUpdateWrapper)new LambdaUpdateWrapper<PlatformAccount>().set((com.baomidou.mybatisplus.core.toolkit.support.SFunction<com.ruoyi.platform.domain.PlatformAccount,java.lang.String>)PlatformAccount::getStatus, accountEnum.getCode())).eq((com.baomidou.mybatisplus.core.toolkit.support.SFunction<com.ruoyi.platform.domain.PlatformAccount,java.lang.String>)PlatformAccount::getId, userId)));
    }
    
    public void removeTweetIds(List<String> asList) {
        List<PlatformAccount> accountList = this.platformAccountRepository.listByIds(asList);
        accountList.forEach(x/* com.ruoyi.platform.domain.PlatformAccount, */ -> {
            while (true) {
                OperateResult<List<String>> execute = new UserTweetsOperate().execute(Operate.builder().targetUserId(x.getId()).proxyId(x.getProxyId()).language(x.getLanguage()).userAgent(x.getUserAgent()).userId(x.getId()).cookie(x.getCookie()).xCsrfToken(x.getxCsrfToken()).build());
                if (CollectionUtils.isEmpty((Collection)execute.getResult())) {
                    break;
                }
                ((List)execute.getResult()).forEach(y/* java.lang.String, */ -> new DeleteTweetOperate().execute(Operate.builder().tweetId(y).userId(x.getId()).proxyId(x.getProxyId()).language(x.getLanguage()).userAgent(x.getUserAgent()).cookie(x.getCookie()).xCsrfToken(x.getxCsrfToken()).build()));
            }
            return;
        });
    }
    
    public PlatformAccountServiceImpl(IPlatformAccountRepository platformAccountRepository) {
        this.platformAccountRepository = platformAccountRepository;
    }
    
    static {
        PlatformAccountServiceImpl.executorService = Executors.newFixedThreadPool(3);
    }
}
